'use strict';

exports.__esModule = true;
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

exports.prepareProps = prepareProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _server = require('react-dom/server');

var _forEach = require('lodash/forEach');

var _forEach2 = _interopRequireDefault(_forEach);

var _reactAddonsTestUtils = require('react-addons-test-utils');

var _LocaleProvider = require('./LocaleProvider');

var _LocaleProvider2 = _interopRequireDefault(_LocaleProvider);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function prepareProps(props, localeProvider) {
  var newProps = {};
  var changed = false;

  (0, _forEach2.default)(props, function (value, key) {
    var isReactElement = (0, _reactAddonsTestUtils.isElement)(value);
    if (!isReactElement) {
      newProps[key] = value;
      return;
    }

    changed = true;

    var _localeProvider$props = localeProvider.props,
        children = _localeProvider$props.children,
        locale = _localeProvider$props.locale,
        rest = _objectWithoutProperties(_localeProvider$props, ['children', 'locale']);

    newProps[key] = (0, _server.renderToStaticMarkup)(_react2.default.createElement(
      _LocaleProvider2.default,
      rest,
      value
    ));
  });

  return changed ? newProps : props;
}

var Translate = (_temp = _class = function (_Component) {
  _inherits(Translate, _Component);

  function Translate() {
    _classCallCheck(this, Translate);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  Translate.prototype.getPath = function getPath() {
    var path = this.props.path;
    var namespace = this.context.namespace;

    if (!namespace) {
      return path;
    }

    var parentPath = namespace.getPath();
    if (!parentPath) {
      return path;
    }

    return parentPath + '.' + path;
  };

  Translate.prototype.render = function render() {
    var _props = this.props,
        tagName = _props.tagName,
        params = _props.params,
        defaultValue = _props.defaultValue,
        className = _props.className,
        _props$props = _props.props,
        props = _props$props === undefined ? {} : _props$props;


    var path = this.getPath();

    var translate = this.context.translate;


    var currentProps = params || this.props;
    var updatedProps = prepareProps(currentProps, translate);
    var text = translate.get(path, updatedProps, defaultValue);

    if (className && !props.className) {
      props.className = className;
    }

    return _react2.default.createElement(tagName, props, text);
  };

  return Translate;
}(_react.Component), _class.contextTypes = _extends({}, _LocaleProvider2.default.childContextTypes, {
  namespace: _react.PropTypes.object
}), _class.propTypes = {
  path: _react.PropTypes.string.isRequired,
  tagName: _react.PropTypes.string.isRequired,
  defaultValue: _react.PropTypes.string,
  description: _react.PropTypes.string,
  className: _react.PropTypes.string,
  params: _react.PropTypes.object,
  props: _react.PropTypes.object
}, _class.defaultProps = {
  tagName: 'span'
}, _temp);
exports.default = Translate;